Unit aej2e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAE10_p;

procedure aej2e(N :Integer; var A :Array of Extended;
                var EV :Array of Extended; var RAB1 :Array of Extended;
                var IERR :Integer);

implementation

procedure aej2e(N :Integer; var A :Array of Extended;
                var EV :Array of Extended; var RAB1 :Array of Extended;
                var IERR :Integer);
var
B,C,D,E,F,G,H :Integer;
I,J,K,L,M,O,P :Extended;
const
SYS051 :Extended = 1.1107652e-16;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20;
begin
IERR := 0;
for B:=1 to N do
 begin
  if ( B = 1 ) 
   then goto _3;
  RAB1[B-1] := A[(B-1)+0*N]*A[(B-2)+2*N];
  if ( RAB1[B-1] ) < 0
   then goto _5
   else if ( RAB1[B-1] ) > 0
         then goto _2
         else goto _1;
_1:
  if ( A[(B-1)+0*N] = 0.e0 ) and ( A[(B-2)+2*N] = 0.e0 ) 
   then goto _2;
  IERR := -(3*N+B);
_2:
  RAB1[B-1] := Sqrt(RAB1[B-1]);
_3:
  EV[B-1] := A[(B-1)+1*N];
_4:
 end;
goto _6;
_5:
IERR := N+B;
_6:
if ( IERR <> 0 ) 
 then goto _20;
IERR := 0;
if ( N = 1 ) 
 then goto _20;
for C:=2 to N do
 begin
_7:
  RAB1[C-2] := RAB1[C-1];
 end;
RAB1[N-1] := 0.0e0;
for E:=1 to N do
 begin
  D := 0;
_8:
  for F:=E to N do
   begin
    if ( F = N ) 
     then goto _10;
    if ( Abs(RAB1[F-1]) <= SYS051*(Abs(EV[F-1])+Abs(EV[F+0])) )
     then goto _10;
_9:
   end;
_10:
  M := EV[E-1];
  if ( F = E ) 
   then goto _14;
  if ( D = 30 ) 
   then goto _19;
  D := D+1;
  L := (EV[E+0]-M)/(2.0e0*RAB1[E-1]);
  if ( Abs(L) > 1.e0 ) 
   then O := Abs(L)*Sqrt(1.e0+IntPower(1.e0/L,2));
  if ( Abs(L) > 1.e0 ) 
   then O := Abs(L)*Sqrt(1.e0+IntPower(1/L,2));
  if ( Abs(L) <= 1.e0 ) 
   then O := Sqrt(L*L+1.e0);
  L := EV[F-1]-M+RAB1[E-1]/(L+Sign(O,L));
  P := 1.0e0;
  J := 1.0e0;
  M := 0.0e0;
  H := F-E;
  for G:=1 to H do
   begin
    C := F-G;
    K := P*RAB1[C-1];
    I := J*RAB1[C-1];
    if ( Abs(K) < Abs(L) ) 
     then goto _11;
    J := L/K;
    O := Sqrt(J*J+1.0e0);
    RAB1[C+0] := K*O;
    P := 1.0e0/O;
    J := J*P;
    goto _12;
_11:
    P := K/L;
    O := Sqrt(P*P+1.0e0);
    RAB1[C+0] := L*O;
    J := 1.0e0/O;
    P := P*J;
_12:
    L := EV[C+0]-M;
    O := (EV[C-1]-L)*P+2.0e0*J*I;
    M := P*O;
    EV[C+0] := L+M;
    L := J*O-I;
_13:
   end;
  EV[E-1] := EV[E-1]-M;
  RAB1[E-1] := L;
  RAB1[F-1] := 0.0e0;
  goto _8;
_14:
  if ( E = 1 ) 
   then goto _16;
  for G:=2 to E do
   begin
    C := E+2-G;
    if ( M >= EV[C-2] ) 
     then goto _17;
    EV[C-1] := EV[C-2];
_15:
   end;
_16:
  C := 1;
_17:
  EV[C-1] := M;
_18:
 end;
goto _20;
_19:
IERR := E;
_20:
if ( IERR <> 0 ) 
 then UTAE10(IERR,N,35);
end;

end.
